// vc5Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "vc5.h"
#include "vc5Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVc5Dlg dialog

CVc5Dlg::CVc5Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVc5Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVc5Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	myfile=NULL;
}

void CVc5Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVc5Dlg)
	DDX_Control(pDX, IDC_CHECK2, m_bin);
	DDX_Control(pDX, IDC_CHECK1, m_check);
	DDX_Control(pDX, IDC_EDIT3, m_serconfig);
	DDX_Control(pDX, IDC_EDIT1, msg);
	DDX_Control(pDX, IDC_LIST1, listbox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVc5Dlg, CDialog)
	//{{AFX_MSG_MAP(CVc5Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_STATIC, OnBitmap)
	ON_WM_DESTROY()
	ON_EN_KILLFOCUS(IDC_EDIT3, OnKillfocusEdit3)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVc5Dlg message handlers

BOOL CVc5Dlg::OnInitDialog()
{
	int bin_text;
	char	string[256];

	CDialog::OnInitDialog();
	bin_text=IDM_ABOUTBOX;
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}



	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// bitmap.LoadBitmap(IDB_BITMAP1);

	// TODO: Add extra initialization here
	counter=0;
	strcpy(filename,AfxGetApp()->GetProfileString("config","logpath","test.txt"));
	strcpy(serconfig,AfxGetApp()->GetProfileString("config","serconfig","COM2: baud=10472 parity=O data=8 stop=2"));
	invert=AfxGetApp()->GetProfileInt("config","invert",0);
	bin_text=AfxGetApp()->GetProfileInt("config","bin",0);
	m_check.SetCheck(invert);
	m_bin.SetCheck(bin_text);
	sprintf(string,"MacLog [%s]",filename);
	SetWindowText(string);
	m_serconfig.SetWindowText(serconfig);
	msg.SetWindowText("0");


	DWORD threadid;
	//start de thread
	thread=CreateThread(NULL,NULL,LogThread,(void*)this,0,&threadid);
	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CVc5Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVc5Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		//CClientDC dc(this);
		//CDC		dc2;
		//BOOL	tt;
		//CBitmap	*b;
		
		//tt=dc2.CreateCompatibleDC(&dc);
		//b=dc2.SelectObject(&bitmap);
		//tt=dc.BitBlt(195,193,80,60,&dc2,0,0,SCRCOPY);
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVc5Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVc5Dlg::OnButton1() // Start Logging
{
	// TODO: Add your control notification handler code here
	msg.SetWindowText("0");
	counter=0;
	scbase->Close();
	
	ResetEvent(readEvent);
	ResetEvent(resetEvent);

	if (myfile)
		fclose(myfile);
	/*
	if (myfile)
	{
		WaitForSingleObject(stopEvent,00);
	}
	*/
	if (m_bin.GetCheck()==1)
	{
		myfile=fopen(filename,"w+b");
	}
	else
	{
		myfile=fopen(filename,"w+t");
	}

	while (listbox.DeleteString(0)!=LB_ERR);
	if (!scbase->Open(serconfig))
	{
		listbox.AddString("Serial COM Failed");
	}
	else
	{
		scbase->SetConfig(serconfig);
		listbox.AddString("Serial COM Initialized");
	}
}

DWORD CVc5Dlg::LogThread(LPVOID p)
{
	CVc5Dlg*	dlg = (CVc5Dlg*)p;
	HANDLE		wevents[3] = {NULL,NULL,NULL};
	char		string[256];
	char		string2[25];
	DWORD		bytes,wobject;
	BYTE		buf[256];
	DWORD		i,j,cnt;

		// create events
	wevents[0]=dlg->stopEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	wevents[1]=dlg->resetEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	wevents[2]=dlg->readEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	
	dlg->scbase = new CSCBase(dlg->resetEvent,dlg->readEvent);
	
	while (TRUE)
	{
		wobject=WaitForMultipleObjects(3,wevents,FALSE,INFINITE);
		if (wobject==WAIT_FAILED)
			wobject=wobject;
		switch (wobject)
		{
		case WAIT_OBJECT_0:		// stopEvent
			{
				CloseHandle(dlg->stopEvent);
				CloseHandle(dlg->resetEvent);
				CloseHandle(dlg->readEvent);
				delete dlg->scbase;
				return 0;
			}
			break;
		case WAIT_OBJECT_0+1:	// resetEvent
			dlg->listbox.AddString("RESET");
			WaitForSingleObject(wevents[0],250);
			ResetEvent(wevents[1]);
			break;
		case WAIT_OBJECT_0+2:	// readEvent
			ResetEvent(wevents[2]);
			//WaitForSingleObject(wevents[0],25);
			bytes=dlg->scbase->Read(&buf,128);
			if (dlg->invert)
			{
				for(i=0;i<bytes;i++)
					buf[i]=dlg->scbase->adapt(buf[i]);
			}
			if (dlg->m_bin.GetCheck()==1)
			{
				fwrite(&buf,1,bytes,dlg->myfile);
			}
			dlg->counter+=bytes;
			sprintf(string,"%lu",dlg->counter);
			dlg->msg.SetWindowText(string);
				
			cnt=0;
			while (bytes>0)
			{
				if (bytes>=16)
					j=16;
				else
					j=bytes;
				bytes-=j;
				string[0]=0x00;
				for(i=0;i<j;i++)
				{
					sprintf(string2,"%02hX ",buf[cnt]);
					cnt++;
					strcat(string,string2);
				}
				dlg->listbox.AddString(string);
				if (dlg->m_bin.GetCheck()==0)
				{
					fprintf(dlg->myfile,"%s\n",string);
				}
			}
			dlg->listbox.SetCaretIndex(dlg->listbox.GetCount()-1,FALSE);
			
			break;
		}
	}
	return 0;
}


void CVc5Dlg::OnDestroy() 
{
	int bin_text;

	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if (myfile)
		fclose(myfile);

	bin_text=m_bin.GetCheck();
	AfxGetApp()->WriteProfileInt("config","bin",bin_text);

	BOOL tt;
	DWORD err;
	tt=SetEvent(stopEvent);
	err=GetLastError();
	WaitForSingleObject(thread,INFINITE);
}

void CVc5Dlg::OnKillfocusEdit3() 
{
	m_serconfig.GetWindowText(serconfig,256);
	AfxGetApp()->WriteProfileString("config","serconfig",serconfig);
	scbase->SetConfig(serconfig);
}

void CVc5Dlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	invert=m_check.GetCheck();
	AfxGetApp()->WriteProfileInt("config","invert",invert);
}
void CVc5Dlg::OnBitmap() 
{
	CAboutDlg	dlg(this);

	dlg.DoModal();
}

void CVc5Dlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	CFileDialog	*dlg;
	char	string[256];

	if (m_bin.GetCheck()==1)
	{
		dlg= new CFileDialog(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"log files (*.bin) | *.bin|All Files (*.*)|*.*||");
		dlg->m_ofn.lpstrDefExt="bin";
	}
	else
	{
		dlg= new CFileDialog(FALSE,NULL,
					NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"log files (*.txt) | *.txt|All Files (*.*)|*.*||");
		dlg->m_ofn.lpstrDefExt="txt";
	}
	
	strcpy(string,filename);
	dlg->m_ofn.lpstrFile=string;
	
	if (dlg->DoModal()==IDOK)
	{
		strcpy(filename,dlg->GetPathName());
		AfxGetApp()->WriteProfileString("config","logpath",filename);
		sprintf(string,"MacLog [%s]",filename);
		SetWindowText(string);
		listbox.AddString("Click (Re)Start for new settings to take effect!");
		listbox.SetCaretIndex(listbox.GetCount()-1,FALSE);
	}
	delete dlg;
}
